--[[A Simple MP3 Player Lib by cools]]--
--6:00 PM 1/27/2007
--Should Work in Any Game, with minor configuration

-- - - - - - - - - - - - - - - - - - - - - - - -
-- delay function. delays in milliseconds
function delay( milli )
	vs=math.floor(milli/60)
	screen.waitVblankStart( vs )
end
-- - - - - - - - - - - - - - - - - - - - - - - -
-- Gets ID3 Tag Info
function gettag(tagname)
	local var = string.find(mdata, tagname)
	if (var) then
		local t = string.sub(mdata, var + 11, var + 9 + string.byte(string.sub(mdata, var+7, var+7)))
		t = string.gsub(t, "\0", "")
		return t
	else 
		return ""
	end
end
-- - - - - - - - - - - - - - - - - - - - - - - -
-- Main Stuff for MP3...
function main_mp3()
	mfile = io.open(music[currentNum],"r")
	mfile:seek("set")
	mdata = mfile:read(5000)
	title = gettag("TIT2\0\0\0")
	artist = gettag("TPE1\0\0\0")
	album = gettag("TALB\0\0\0")
	if title ~= "" and artist ~= "" and album ~= "" and string.len(title.." by "..artist.." from "..album)*8 < 512 then
		mp3info = title.." by "..artist.." from "..album
	elseif title ~= "" and artist ~= "" and string.len(title.." by "..artist)*8 < 512 then
		mp3info = title.." by "..artist
	elseif title ~= "" and string.len(title)*8 < 512 then
		mp3info = title
	else mp3info = string.sub(music[currentNum],15) end
	
	mfile:close()
	
	if string.len(mp3info)*8 < 512 then
		sbuffer = Image.createEmpty(string.len(mp3info)*8,10)
	else
		sbuffer = Image.createEmpty(512,10)
	end
	sbuffer:print(0,0,mp3info)

	Mp3.load(music[currentNum])
	Mp3.play()
end
-- - - - - - - - - - - - - - - - - - - - - - - -
-- Init MP3 before main loop!
function init_mp3()
	music = {}
	fold = false
	pspfold = {}
	pspfold = System.listDirectory("ms0:/PSP")
	for l = 1, table.getn(pspfold) do
		if pspfold[l].directory == true then
			if string.lower(pspfold[l].name) == "music" then fold = true end
		end
	end

	if fold == true then
		musicfold = {}
		musicfold = System.listDirectory("ms0:/PSP/MUSIC")

		for i = 1, table.getn(musicfold) do
			if musicfold[i].directory == false then
				if string.lower(string.sub(musicfold[i].name,-4)) == ".mp3" then
					music[i-2] = "./../../MUSIC/"..musicfold[i].name
				end
			end
		end

		currentNum = 1

		if music[1] ~= nil then
			main_mp3()
		else
			mp3info = "No Tracks Available"
			sbuffer = Image.createEmpty(string.len(mp3info)*8,10)
			sbuffer:print(0,0,mp3info)
		end
	else
		mp3info = "Music Folder Not Found"
		sbuffer = Image.createEmpty(string.len(mp3info)*8,10)
		sbuffer:print(0,0,mp3info)
	end
end
-- - - - - - - - - - - - - - - - - - - - - - - -
-- Plays MP3's! -- Call in Main Loop!
function play_mp3()
	if music[1] ~= nil and fold == true then
		if Mp3.EndOfStream() == "true" then
			Mp3.stop()
			currentNum = currentNum + 1
			if currentNum > table.getn(music) then currentNum = 1 end
			main_mp3()
		end
		if pad:l() then
			Mp3.stop()
			currentNum = currentNum - 1
			if currentNum < 1 then currentNum = table.getn(music) end
			main_mp3()
			delay(500)
		end
		if pad:r() then
			Mp3.stop()
			currentNum = currentNum + 1
			if currentNum > table.getn(music) then currentNum = 1 end
			main_mp3()
			delay(500)
		end
	end
end
